<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BldgRoom StructType
 * @package Dg
 * @subpackage Structs
 */
class DgBldgRoom extends AbstractStructBase
{
    /**
     * The _
     * @var string
     */
    public $_;
    /**
     * The BldgNameIndicator
     * @var bool
     */
    public $BldgNameIndicator;
    /**
     * Constructor method for BldgRoom
     * @uses DgBldgRoom::set_()
     * @uses DgBldgRoom::setBldgNameIndicator()
     * @param string $_
     * @param bool $bldgNameIndicator
     */
    public function __construct($_ = null, $bldgNameIndicator = null)
    {
        $this
            ->set_($_)
            ->setBldgNameIndicator($bldgNameIndicator);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \dgsoft\StructType\DgBldgRoom
     */
    public function set_($_ = null)
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($_)), __LINE__);
        }
        $this->_ = $_;
        return $this;
    }
    /**
     * Get BldgNameIndicator value
     * @return bool|null
     */
    public function getBldgNameIndicator()
    {
        return $this->BldgNameIndicator;
    }
    /**
     * Set BldgNameIndicator value
     * @param bool $bldgNameIndicator
     * @return \dgsoft\StructType\DgBldgRoom
     */
    public function setBldgNameIndicator($bldgNameIndicator = null)
    {
        // validation for constraint: boolean
        if (!is_null($bldgNameIndicator) && !is_bool($bldgNameIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($bldgNameIndicator)), __LINE__);
        }
        $this->BldgNameIndicator = $bldgNameIndicator;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgBldgRoom
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
